package router

import (
	"context"
	"net/http"

	"github.com/gin-gonic/gin"
	"github.com/mhaya/game/game_cluster/internal/mdb"
)

func Auth() gin.HandlerFunc {
	return func(c *gin.Context) {
		tokenString := c.GetHeader("Token")
		if tokenString == "" {
			c.AbortWithStatusJSON(http.StatusUnauthorized, gin.H{
				"msg": "token is empty",
			})
			return
		}
		result, err := mdb.RDB.Get(context.Background(), tokenString).Result()
		if err != nil {
			return
		}
		if result == "" {
			c.AbortWithStatusJSON(http.StatusUnauthorized, gin.H{
				"msg": "token is invalid",
			})
			return
		}
		c.Next()
	}
}
